> For the complete documentation index, see [llms.txt](https://docs.ngsurvey.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ngsurvey.com/ar/form-management/tasks/task-items/webhook.md).

# Webhooks

## ☁️ ما هي Webhooks؟

تعد Webhooks طريقة ممتازة لإرسال بيانات المستجيب وإجاباته إلى أي نقطة نهاية API تعتمد على HTTP بمجرد تسجيل المستجيب في قاعدة بيانات ngSurvey.

## 🔅 خصائص Webhooks

* **`عنوان URL الخاص بالWebhook`** لنقطة نهاية REST API أو خادم HTTP التي يجب أن تستلم إرسال حمولة JSON الخاصة بالمستجيب.
* **`قالب تحويل الحمولة`** يُستخدم لتغيير بنية حمولة JSON المرسلة إلى بنية كائن مخصصة أخرى.

## 🔤 صيغة الإرسال

يتم إرسال المستجيب وإجاباته كحمولة بتنسيق JSON باستخدام فعل HTTP post. يمكن تخصيص حمولة JSON الافتراضية أدناه باستخدام [قالب تحويل الحمولة](/ar/form-management/tasks/task-items/webhook/webhooks-payload-transform.md).

```javascript
{
  respondent: {
    id: string;
    surveyId: string;
    panelistId: string;
    contextUsername: string
    resumeUId: string;
    resumePageId: string;
    startDate: Date;
    voteDate: Date;
    iPSource: string;
    changeUID: string;
    progressSaveDate: Date;
    languageCode: string;
    timeToEnd: number;
    validated: boolean;        
  },
  answers: [{
      respondentId: string,
      value:string,
      answerId": string,
      answerText": string,
      questionId": string,
      questionAlias": string,
      questionText": string,
      sectionNumber": number
  }],
  visitedPages: [{
    id: string;
    respondentId: string;
    visitTime: string;
  }],
  dataAttributes: [{
    securityItemId: string;
    respondentId: string;
    attributeName: string;
    attributeValue: string;
  }],
  querystring: string
}
```

{% hint style="info" %}
الإجابات المشفرة باستخدام [مقيدة](/ar/data-encryption/data-classification/restricted.md) سيتم إرسال تصنيف البيانات باعتبارها رسالة PGP مشفرة.&#x20;
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ngsurvey.com/ar/form-management/tasks/task-items/webhook.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
